'************ GLCD_4.BAS ***************
'****** Jure Mikeln, July 2012 *********
'****** Copyright AX elektronika *******



'large buttons

'calibration at 9 points


'we draw small buttons and use Touch panel
'used with calibration
'when started for the first time press button on PortD.0 so that you see
'message: Calibration
'then press each button on the screen to calibrate
'calibrated values are stored to EEPROM

$regfile = "m16def.DAT"
'$regfile = "m32def.DAT"
$crystal = 8000000
'$crystal = 14456800
'$crystal = 11059200
'$crystal = 24000000
'$baud = 19200

'$loadersize = 512
$hwstack = 100
$swstack = 75
$framesize = 40
$lib "glcdKS108.lib"                                        'Include the library for the KS-108 controler



Config Graphlcd = 128 * 64sed , Dataport = Portc , Controlport = Portb , Ce = 0 , Ce2 = 1 , Cd = 2 , Rd = 3 , Reset = 5 , Enable = 4 , Mode = 8



'The dataport is the portname that is connected to the data lines of the LCD
'The controlport is the portname which pins are used to control the lcd
'CE =CS1  Chip select
'CE2=CS2  Chip select second chip
'CD=Data/instruction
'RD=Read
'RESET = reset
'ENABLE= Chip Enable
Cls

Config Adc = Single , Prescaler = Auto , Reference = Avcc   'Setting up the a/d convertor

Showpic 0 , 0 , Logose                                      'Svet elektronike logo
Wait 1


Cls




Dim X As Word , Y As Word , I As Byte , Y1 As Word , Y2 As Word , X1 As Word , X2 As Word , Xa As Word , Xb As Word , Xc As Word , Xd As Word,
Dim Ya As Word , Yb As Word , Yc As Word , Yd As Word , Done As Bit , Tempx As Word , Tempy As Word

Dim Xy(16) As Word , Yx(16) As Word , I1 As Byte , J As Byte , Ind As Byte , K As Byte

'******** Function tells if read value is within alowed area around the pressed area ******
'******** If it is, its value = 1, else = 0 ******
'******** Function is set X & Y of a point, function calculates deviation from that point in x & y direction *****
'******** Before that we read values from Touch screen in X & Y and are stored to Prebrano_x and Prebrano_y *****
'******** and calculate coordinates of four points that sorounds pressed point *****
      Dim Min_x As Word , Max_x As Word
      Dim Min_y As Word , Max_y As Word


Declare Function Within_area(byval Ind As Byte) As Byte

'Config Portb = Output
'Portb = 255


'**** read values are stored into these two variables ****
'**** Later we read them in Function "Znotraj_obmoja", where it's explored whether button was pressed or not ****
'Dim Prebrano_x As Word
'Dim Prebrano_y As Word
Const Offset_x = 6                                          ' +/- offset "X" for allowed area
'Const Offset_y = 4                                          ' +/- offset "Y" for allowed area
Dim Pressed As Byte                                         '= 0, if not pressed

'Dim Tipka(17,2) As Word                                   'coordinates of points

Dim Keypad_x(17) As Eram Word
Dim Keypad_y(17) As Eram Word
            '17 zato, da imam eno pom vr.
'Const Korak = 4

Config Portd.3 = Input                                      'at start we press PortD.0 for calibration
If Pind.3 = 0 Then
   Done = 0
   Else
   Done = 1
End If

'variable "Done" sets whether calibration was done or not Done=0: means calibration was not performed

Setfont Font8x8
Start Adc                                                   ' Start the ad convertor
' =====Main=====
Main:

If Done = 0 Then                                            'if not calibrated then calibrate
   Gosub Calibration
End If

Gosub Blank                                                 '         'display blank keypad


Do

Gosub Pressed_keypad

Config Portd.1 = Input
If Pind.1 = 0 Then
   Gosub Prikazi_x
End If



Loop

End


'-------------------------------------------------------------------------------
'******** Function tells if read value is within alowed area around the pressed area ******

Function Within_area(byval Ind As Byte) As Byte
          'old value of fucntion is erased
          Within_area = 0
           Min_x = Keypad_x(ind) - 25                       'Offsetx
           Max_x = Keypad_x(ind) + 25                       'Offset_x
           Min_y = Keypad_y(ind) - 15                       'Offset_y
           Max_y = Keypad_y(ind) + 15                       'Offset_y

           '** does x suits ? ****
           If X >= Min_x And X <= Max_x Then
                   '** does y suits ? ****
                   If Y >= Min_y And Y <= Max_y Then
                   Within_area = 1
                   Else
                   Within_area = 0
                   End If
           End If

End Function
'--------------------------------------------------------------------------------------------------

Readtouch:
Y = 0
For J = 0 To 15                                             'read touch

Config Porta.3 = Output                                     'pin1 (Y+)
Config Porta.1 = Output                                     ' PIN3 (Y-)
Set Porta.3                                                 'PIN2 (Y-)
Reset Porta.1                                               'PIN4 (Y+)
Config Pina.2 = Input                                       ' (X-)set as input
Config Pina.0 = Input                                       ' (X+)

Waitus 1                                                    'wait to stabilize
Y1 = Getadc(2)                                              ' (X-)
Y2 = 1024 - Y1
Y = Y2 + Y                                                  'read A/D
Next
Y = Y / 15
X = 0
For J = 0 To 15                                             'invertiraj value

Config Porta.2 = Output                                     'repeat same for X coordinate
Config Porta.0 = Output                                     '
Reset Porta.2
Set Porta.0
Config Pina.1 = Input
Config Pina.3 = Input

Waitus 1
X1 = Getadc(1)                                              '
X2 = 1024 - X1
X = X2 + X
Next
X = X / 15
'J = 0
Return

'-------------------------------------------------------------------------------
'show blank buttons
Blank:

Showpic 0 , 0 , Tipke9x

Return


'-------------------------------------------------------------------------------
'calibration

Calibration:
I1 = 4
X = 0
Y = 0

Lcdat 1 , 1 , "CALIBRATION"                                 ' ; Y ;
Wait 1
Cls
                                                      '
For I = 1 To 9 Step 1
'--------------------------------------------------------------------------------------------------

Ponovi:
   Select Case I                                            'display 9 images to get 9 calibration points

   Case 1 : Showpic 0 , 0 , Tipke9x1
   Case 2 : Showpic 0 , 0 , Tipke9x2
   Case 3 : Showpic 0 , 0 , Tipke9x3
   Case 4 : Showpic 0 , 0 , Tipke9x4

   Case 5 : Showpic 0 , 0 , Tipke9x5
   Case 6 : Showpic 0 , 0 , Tipke9x6
   Case 7 : Showpic 0 , 0 , Tipke9x7
   Case 8 : Showpic 0 , 0 , Tipke9x8

   Case 9 : Showpic 0 , 0 , Tipke9x9

'(
   Case 10 : Showpic 0 , 0 , Tabela32
   Case 11 : Showpic 0 , 0 , Tabela33
   Case 12 : Showpic 0 , 0 , Tabela34

   Case 13 : Showpic 0 , 0 , Tabela_1_3
   Case 14 : Showpic 0 , 0 , Tabela42
   Case 15 : Showpic 0 , 0 , Tabela43
   Case 16 : Showpic 0 , 0 , Tabela44
')
   End Select
   Wait 1

   Gosub Readtouch
'   Lcdat 3 , 30 , "X= " ; X                                 '' ;display value of X ;
'   Lcdat 5 , 30 , "Y= " ; Y                                 '' ;display value of Y ;
' Wait 2
   If X < 100 Then
         Showpic 0 , 0 , Not_ok
         Waitms 100
      Goto Ponovi


      Showpic 0 , 0 , Not_ok
      Waitms 200
      Else
      Showpic 0 , 0 , Ok
      Waitms 100
   End If

   Keypad_x(i) = X
   Keypad_y(i) = Y

   Wait 1

   Waitms 200
Next I



 Done = 1
Cls


I = 0

Return



'-------------------------------------------------------------------------------
'display image of pressed button

Pressed_keypad:

Gosub Readtouch


If X > 10 Or Y > 10 Then                                    'added condition to be sure that button was pressed

For I = 1 To 9


Pressed = Within_area(i)


If Pressed = 1 Then                                         'if aquired value equals with stored value

Select Case I


Case 1 : Showpic 0 , 0 , Tipke9x1                           'then display coresponding image
Case 2 : Showpic 0 , 0 , Tipke9x2
Case 3 : Showpic 0 , 0 , Tipke9x3
Case 4 : Showpic 0 , 0 , Tipke9x4
Case 5 : Showpic 0 , 0 , Tipke9x5
Case 6 : Showpic 0 , 0 , Tipke9x6
Case 7 : Showpic 0 , 0 , Tipke9x7
Case 8 : Showpic 0 , 0 , Tipke9x8
Case 9 : Showpic 0 , 0 , Tipke9x9

'(
Case 10 : Showpic 0 , 0 , Tabela32
Case 11 : Showpic 0 , 0 , Tabela33
Case 12 : Showpic 0 , 0 , Tabela34
Case 13 : Showpic 0 , 0 , Tabela41
Case 14 : Showpic 0 , 0 , Tabela42
Case 15 : Showpic 0 , 0 , Tabela43
Case 16 : Showpic 0 , 0 , Tabela44
')
End Select

Exit For
End If

Next

Pressed = 0
End If

Waitms 30
Return


'-------------------------------------------------------------------------------

Prikazi_x:                                                  'show stored values (this is for debugging)

Cls
For I = 1 To 16
Tempx = Keypad_x(i)
Tempy = Keypad_y(i)
Prikazi:
Lcdat 1 , 1 , "I= " ; I ; "X= " ; Tempx ; "    "
Lcdat 2 , 1 , "Y= " ; Tempy ; "    "
Wait 1
Config Portd.2 = Input
   If Pind.2 = 0 Then                                       'when pressed go to next value of coordinate
   Next
   Else
   Goto Prikazi
End If
Return

'-------------------------------------------------------------------------------



End


'-------------------------------------------------------------------------------
'stored images and fonts


$include "font8x8.font"
Logose:
$bgf "logose.bgf"

Tipke9x:
$bgf "Tipke9x.bgf"

Tipke9x1:
$bgf "Tipke9x1.bgf"

Tipke9x2:
$bgf "Tipke9x2.bgf"

Tipke9x3:
$bgf "Tipke9x3.bgf"

Tipke9x4:
$bgf "Tipke9x4.bgf"

Tipke9x5:
$bgf "Tipke9x5.bgf"

Tipke9x6:
$bgf "Tipke9x6.bgf"

Tipke9x7:
$bgf "Tipke9x7.bgf"

Tipke9x8:
$bgf "Tipke9x8.bgf"

Tipke9x9:
$bgf "Tipke9x9.bgf"

Ok:
$bgf "Tipke9xOK.bgf"

Not_ok:
$bgf "Tipke9x.bgf"