'********** MEGACLOCK.BAS **************
'****** Jure Mikeln, July 2012 *********
'****** Copyright AX elektronika *******


'------------------------------------------------------------
'                      MEGACLOCK.BAS
'                  (c) 2000-2002 MCS Electronics
'------------------------------------------------------------
'This example shows the new TIME$ and DATE$ reserved variables
'With the 8535 and timer2 or the Mega103 and TIMER0 you can
'easily implement a clock by attaching a 32.768 KHz xtal to the timer
'And of course some BASCOM code


'adapted Jure Mikeln, July 2012

'simple clock in MegaPin
'in socket J12 @ MegaPin (J7 @ MiniPin II) put XTAL 32,768 kHz
'jumper J5 @ MegaPin (J3 @ MiniPin II) (LEDs on PortC) should be disabled
'set ATMega16/32 fuse to internal RC 8 MHz
'used 2x8 LCD


$regfile = "m16def.dat"
'$regfile = "m32def.dat"
$crystal = 8000000                                          'used crystal frequency
$baud = 200                                                 'use baud rate
$hwstack = 32                                               'default use 32 for the hardware stack
$swstack = 10                                               'default use 10 for the SW stack
$framesize = 40                                             'default use 40 for the frame space



Enable Interrupts


Config Lcd = 16 * 1                                         '2x8 LCD
Config Lcdbus = 4
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.2 , Rs = Portb.1

'Config Lcdpin = Pin , Db7 = Porta.7 , Db6 = Porta.6 , Db5 = Porta.5 , Db4 = Porta.4 , E = Porta.2 , Rs = Porta.1


'[now init the clock]
Config Clock = Soft                                         'this is how simple it is
'The above statement will bind in an ISR so you can not use the TIMER anymore!
'For the M103 in this case it means that TIMER0 can not be used by the user anymore

'assign the date to the reserved date$
'The format is MM/DD/YY
Date$ = "02/11/01"

'assign the time, format in hh:mm:ss military format(24 hours)
'You may not use 1:2:3 !! adding support for this would mean overhead
'But of course you can alter the library routines used

Time$ = "10:14:00"

'---------------------------------------------------
'optional use the european date time library
'$lib "eurotimedate.lbx"
'unremark above line for euro date DD-MM-YY
'---------------------------------------------------

'clear the LCD display
Cls


Do
   Home Upper                                               'cursor home
   Lcd Time$
   Lowerline
   Lcd Date$                                                '; "  " ; Time$                                  'show the date and time
   Powersave
 Loop

'The clock routine does use the following internal variables:
'_day , _month, _year , _sec, _hour, _min
'These are all bytes. You can assign or use them directly
'For the _year variable only the year is stored, not the century
End

'--------------------------------------------------------