'********** MEGACLOCK1.BAS *************
'****** Jure Mikeln, July 2012 *********
'****** Copyright AX elektronika *******

' this example includes simple routines to set time manually with Keyboard

'------------------------------------------------------------
'                      MEGACLOCK.BAS
'                  (c) 2000-2002 MCS Electronics
'------------------------------------------------------------
'This example shows the new TIME$ and DATE$ reserved variables
'With the 8535 and timer2 or the Mega103 and TIMER0 you can
'easily implement a clock by attaching a 32.768 KHz xtal to the timer
'And of course some BASCOM code

'adapted Jure Mikeln,July 2012

'simple clock in MegaPin
'in socket J12 @ MegaPin (J7 @ MiniPin II) put XTAL 32,768 kHz
'jumper J5 @ MegaPin (J3 @ MiniPin II) (LEDs on PortC) should be disabled
'set ATMega16/32 fuse to internal RC 8 MHz
'used 2x8 LCD


'$baud = 1200
'$crystal = 327680
'$regfile = "attiny85.dat"
$regfile = "m16def.dat"
'$regfile = "m32def.dat"

$crystal = 8000000                                          ' used crystal frequency

$baud = 200                                                 ' use baud rate

$hwstack = 32                                               ' default use 32 for the hardware stack

$swstack = 10                                               ' default use 10 for the SW stack

$framesize = 40                                             ' default use 40 for the frame space

Dim Choose As Byte                                          'Set sec (0), minutes (1), hours (2)



'This example is written for the STK300 with M103
Enable Interrupts

'[configure LCD]
'$lcd = &HC000                                               'address for E and RS
'$lcdrs = &H8000                                             'address for only E
'Config Lcd = 20 * 4                                         'nice display from bg micro
'Config Lcdbus = 4                                           'we run it in bus mode and I hooked up only db4-db7
'Config Lcdmode = Bus                                        'tell about the bus mode

Config Lcd = 16 * 1
Config Lcdbus = 4
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.2 , Rs = Portb.1

'Config Lcdpin = Pin , Db7 = Porta.7 , Db6 = Porta.6 , Db5 = Porta.5 , Db4 = Porta.4 , E = Porta.2 , Rs = Porta.1


'[now init the clock]
Config Clock = Soft                                         'this is how simple it is
'The above statement will bind in an ISR so you can not use the TIMER anymore!
'For the M103 in this case it means that TIMER0 can not be used by the user anymore

'assign the date to the reserved date$
'The format is MM/DD/YY
Date$ = "11/11/00"

'assign the time, format in hh:mm:ss military format(24 hours)
'You may not use 1:2:3 !! adding support for this would mean overhead
'But of course you can alter the library routines used

Time$ = "02:20:00"

'---------------------------------------------------
'optional use the european date time library
'$lib "eurotimedate.lbx"
'unremark above line for euro date DD-MM-YY
'---------------------------------------------------

'clear the LCD display
Cls

Config Portd.0 = Input                                      'increments
Config Portd.1 = Input                                      'select
Config Portd.2 = Input                                      'decrement


Do
  Locate 1 , 1                                              'cursor home
  Lcd Time$
  Debounce Pind.0 , 0 , Increment_sub , Sub
  Debounce Pind.3 , 0 , Choose_sub , Sub
  Debounce Pind.2 , 0 , Decrement_sub , Sub
  'Lowerline
 ' Lcd _sec
  'Lcd Date$ ; "  " ; Time$                                  'show the date and time
   Select Case Choose

   Case 0 : Locate 2 , 2
   Lcd "      ^" : Goto Fwd
   Case 1 : Locate 2 , 2
   Lcd "   ^     " : Goto Fwd
   Case 2 : Locate 2 , 2
   Lcd "^         "
   Fwd:
   End Select

Loop

'The clock routine does use the following internal variables:
'_day , _month, _year , _sec, _hour, _min
'These are all bytes. You can assign or use them directly
'For the _year variable only the year is stored, not the century
End

'--------------------------------------------------------
'sub for incrementing

Increment_sub:
Select Case Choose

Case 0 : Incr _sec
Case 1 : Incr _min
Case 2 : Incr _hour

End Select
If _min > 59 Then
   _min = 0
End If

If _hour > 23 Then
   _hour = 0
End If

If _sec > 59 Then
   _sec = 0
End If
Return

'--------------------------------------------------------
'sub for decrementing


Decrement_sub:
Select Case Choose

Case 0 : Decr _sec
Case 1 : Decr _min
Case 2 : Decr _hour

End Select

If _min < 1 Or _min > 59 Then
   _min = 0
End If

If _hour < 1 Or _hour > 23 Then
   _hour = 0
End If

If _sec < 1 Or _sec > 59 Then
   _sec = 0
End If

Return

'--------------------------------------------------------
'sub for selecting day/hour/minute

Choose_sub:

Incr Choose
If Choose > 2 Then
   Choose = 0
End If
Return